SystemOrganization addCategory: #'Parsers-Misc'!

!String methodsFor: '*parsers-misc' stamp: 'jmck 3/20/2010 15:44'!
asTitle
	^TitleParser default parse: self! !

PPCompositeParser subclass: #TitleParser
	instanceVariableNames: 'titleFirstWord titleWord title titleWords'
	classVariableNames: 'Prepositions Default'
	poolDictionaries: ''
	category: 'Parsers-Misc'!

!TitleParser class methodsFor: 'as yet unclassified' stamp: 'jmck 3/20/2010 14:11'!
default
	^Default ifNil: [ Default := self new ]! !

!TitleParser class methodsFor: 'as yet unclassified' stamp: 'jmck 3/20/2010 15:30'!
initialize
	"TitleParser initialize"
	^ Prepositions := OrderedCollection new
		add: #a;
		add: #the;
		add: #and;
		add: #with; 
		add: #in;
		add: #on;
		add: #of;
		add: #at;
		add: #to;
		add: #for;
		yourself! !

!TitleParser class methodsFor: 'as yet unclassified' stamp: 'jmck 3/20/2010 12:56'!
prepositions
	^ Prepositions! !

!TitleParser methodsFor: 'as yet unclassified' stamp: 'jmck 3/20/2010 14:58'!
start
	^title end! !

!TitleParser methodsFor: 'as yet unclassified' stamp: 'jmck 3/20/2010 15:26'!
title
	^titleFirstWord , titleWords ==> [ :nodes | nodes first , ' ', nodes second ]! !

!TitleParser methodsFor: 'as yet unclassified' stamp: 'jmck 3/20/2010 14:55'!
titleFirstWord
	^#word asParser plus token ==> [:result | result value asString capitalized ]! !

!TitleParser methodsFor: 'as yet unclassified' stamp: 'jmck 3/20/2010 15:23'!
titleWord
	^(#word asParser plus) token ==> [ :token |
		(self class prepositions includes: token value)
			ifFalse: [ token value asString capitalized ]
			ifTrue: [ token value asString ] ]! !

!TitleParser methodsFor: 'as yet unclassified' stamp: 'jmck 3/20/2010 15:23'!
titleWords
	^ titleWord star ==> [ :nodes | 
		String streamContents: [ :strm |
			nodes do: [ :each | strm nextPutAll: each ] separatedBy: [ strm nextPut: $ ]]]! !
TitleParser initialize!
